// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItem;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class T2CconfigWriter {

    private static FileConfiguration config;

    public static void createConfig(File configFile, T2CconfigItem[] values, String... header) {
        boolean exist = configFile.exists();
        if (!exist) {
            configFile.getParentFile().mkdirs();
            try {
                configFile.createNewFile();
            } catch (IOException e) {
                e.printStackTrace();
                return;
            }
        } else exist = true;

        config = YamlConfiguration.loadConfiguration(configFile);
        Map<String, List<String>> comments = new LinkedHashMap<>();

        T2CLanguageEnum lang = T2CLanguageEnum.english;
        try {
            lang = T2CLanguageEnum.valueOf(config.getString(values[0].getLanguagePath().replace(".yml", "")));
        } catch (Exception ignore) {
        }

        for (T2CconfigItem item : values) {
            if (item.getForceSet() || !exist) {
                config.addDefault(item.getPath(), item.getValue());

                List<String> commandList = item.getComments().get(lang);
                if (commandList != null) {
                    comments.put(item.getPath(), commandList);
                }
            }
        }

        // Copy default values if they are missing
        config.options().copyDefaults(true);

        T2CymlWriter.saveConfigWithComments(configFile, config, comments, header);
        readConfig(config, values);
    }

    private static void readConfig(FileConfiguration config, T2CconfigItem[] values) {
        for (T2CconfigItem value : values) {
            value.setValue(config.get(value.getPath()));
        }
    }
}
