// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItemLanguages;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.*;

public class T2CconfigWriterLanguage {

    private static FileConfiguration config;

    public static void createConfig(String prefix,File path, T2CconfigItemLanguages[] values, String loadConfig,boolean pluginStart, String... header) {

        File f = new File(path + "/languages/");
        f.mkdirs();
        File[] fileArray = f.listFiles();
        if(fileArray.length == 0){
            List<File> zw = new ArrayList<>();
            for(T2CLanguageEnum lan : T2CLanguageEnum.values()){
                if(values[0].getLanguage().containsKey(lan)){
                    zw.add(new File(path + "/languages/" + lan.name() + ".yml"));
                }
            }
            fileArray = zw.toArray(new File[0]);
        }
        for (File langFile : fileArray) {
            if (langFile.getName().endsWith(".yml")) {
                T2CLanguageEnum lang = T2CLanguageEnum.english;
                try {
                    lang = T2CLanguageEnum.valueOf(langFile.getName().replace(".yml", ""));
                } catch (Exception ignore) {
                }

                if (!langFile.exists()) {
                    langFile.getParentFile().mkdirs();
                    try {
                        langFile.createNewFile();
                    } catch (IOException e) {
                        e.printStackTrace();
                        return;
                    }
                }
                Map<String, List<String>> comments = new LinkedHashMap<>();
                // Copy default values if they are missing
                config = YamlConfiguration.loadConfiguration(langFile);
                config.options().copyDefaults(true);
                for (T2CconfigItemLanguages item : values) {
                    config.addDefault(item.getPath(), item.getLanguage().get(lang));


                    List<String> commandList = item.getComments().get(lang);
                    if (commandList != null) {
                        comments.put(item.getPath(), commandList);
                    }
                }
                T2CymlWriter.saveConfigWithComments(langFile, config, comments, header);
            }
        }
        readConfig(prefix,path,values, loadConfig, pluginStart);
    }

    private static void readConfig(String prefix, File path, T2CconfigItemLanguages[] values, String loadConfig, boolean pluginStart) {
        String selectMSG;
        File msg;
        msg = new File(path, "languages/" + loadConfig + ".yml");
        if (!msg.isFile()) {
            T2Ctemplate.setCenterAligned(prefix, "", pluginStart);
            T2Ctemplate.setCenterAligned(prefix, "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", pluginStart);
            T2Ctemplate.setCenterAligned(prefix, "§4The selected §c" + loadConfig + " §4language file was not found.", pluginStart);
            T2Ctemplate.setCenterAligned(prefix, "§6The default language §e" + T2CLanguageEnum.english.name() + " §6is used!", pluginStart);
            T2Ctemplate.setCenterAligned(prefix, "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", pluginStart);
            T2Ctemplate.setCenterAligned(prefix, "", pluginStart);
            msg = new File(path, "languages/" + T2CLanguageEnum.english.name() + ".yml");
            selectMSG = T2CLanguageEnum.english.name();
        } else selectMSG = loadConfig;
        YamlConfiguration yml = YamlConfiguration.loadConfiguration(msg);
        for (T2CconfigItemLanguages value : values) {
            value.setValue(yml.get(value.getPath()));
        }
        T2Ctemplate.setCenterAligned(prefix, "§2Language successfully selected to: §6" + selectMSG, pluginStart);
    }
}
